package android.aLlum;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.telephony.TelephonyManager;
import android.text.method.ScrollingMovementMethod;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.RadioGroup;
import android.widget.TextView;

public class actComanda extends Activity {
	
	private EditText nomCom;
	
	
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
    	Comanda comanda;
        super.onCreate(savedInstanceState);
        setContentView(R.layout.comanda);

        //Obtenim les dades de la comanda
        Bundle bundle = getIntent().getExtras();
        comanda = Controler.getInstance().getComanda(bundle.getInt("pos"));

        // Si s una comanda ja existent mostrem el nom
        nomCom = (EditText) findViewById(R.id.txtNomCom);
        if (comanda.getId() != -1) {
	        nomCom.setText(comanda.getNom());
        }
        
        AdaptadorProd adaptador =  new AdaptadorProd(this);
        ListView lstOpciones = (ListView)findViewById(R.id.lvLListaProd);
        
        lstOpciones.setAdapter(adaptador);
        lstOpciones.setOnItemClickListener(new OnItemClickListener() {
            public void onItemClick(AdapterView<?> a, View v, int position, long id) {
				Intent intent = new Intent(v.getContext(), actProducte.class);
				Bundle bundle = new Bundle();
				bundle.putInt("pos", position);
				intent.putExtras(bundle);	
				startActivityForResult(intent, 0);
				Log.v("OnClic", "OnClick " +  Controler.getInstance().getProducte(position).getUnitats());
            }
        });
        
        // Enviament de la comanda
        Button btSend     = (Button) findViewById(R.id.btSend);        
        btSend.setOnClickListener(new View.OnClickListener() {
		EditText desti = (EditText) findViewById(R.id.txtDesti);
			public void onClick(View v) {
				String  sMsg = "";
				String  sDesti;
				Boolean bVenda;
		        RadioGroup rgTipus = (RadioGroup) findViewById(R.id.rgVenLlo);

				sDesti = desti.getText().toString();
				if (sDesti.compareTo("") == 0) {
					Controler.getInstance().mostrarMissatge(actComanda.this, "Error", 
							"El dest no pot ser null");
					return;
				}
				
				if (rgTipus.getCheckedRadioButtonId() == R.id.rbVenda) {
					bVenda = true;
				} else if (rgTipus.getCheckedRadioButtonId() == R.id.rbLloguer) {
					bVenda = false;
				} else {
					Controler.getInstance().mostrarMissatge(actComanda.this, "Error", 
							"Cal seleccionar venda o lloguer");
					return;
				}
				
				Intent intent = new Intent(Intent.ACTION_SEND);
				intent.setType("plain/text");
				intent.putExtra(Intent.EXTRA_EMAIL, new String[] {sDesti});
				intent.putExtra(Intent.EXTRA_SUBJECT, "Petici pressupost");
				if (bVenda) {
					sMsg = "Petici pressupost de VENDA\n\n";
				} else {
					sMsg = "Petici pressupost de LLOGUER\n\n";					
				}
				TextView tDesc = (TextView) findViewById(R.id.tvDescProd);
				sMsg += tDesc.getText().toString();
				intent.putExtra(Intent.EXTRA_TEXT, sMsg);
				startActivity(Intent.createChooser(intent, "Title"));
			}
		});        

        // Desar la comanda
        Button btDesar = (Button) findViewById(R.id.btDesarCom);
        btDesar.setOnClickListener(new View.OnClickListener() {

        	public void onClick(View v) {
        		EditText tNom = (EditText) findViewById(R.id.txtNomCom);
        		
        		if (tNom.getText().toString().compareTo("")== 0) {
        			Controler.getInstance().mostrarMissatge(actComanda.this, "Error", 
							"s necessari un nom de comanda");	
        		} else {
        			desarComanda();
        			finish();
        		}
			}
		});        

    }

    @Override
    public void onResume()
    {
        actualitzarDescProd();
        super.onResume();
    }

    public void actualitzarDescProd() {
    	TextView tDesc = (TextView) findViewById(R.id.tvDescProd);
    	tDesc.setMovementMethod(new ScrollingMovementMethod());
    	tDesc.setText(Controler.getInstance().getDescripcioProd());  	
    }
    
    private void desarComanda() {
    	String sNom = nomCom.getText().toString();
    	Controler.getInstance().setNomComanda(sNom);
    	Controler.getInstance().desarComanda();
    }
  
    class AdaptadorProd extends ArrayAdapter<Producte> {
    	
    	Activity context;
    	
    	AdaptadorProd(Activity context) {
    		super(context, R.layout.item_prod, Controler.getInstance().getComanda().getLlistaProd());
    		this.context = context;
    	}
    	
    	public View getView(int position, View convertView, ViewGroup parent) {
    		
			LayoutInflater inflater = context.getLayoutInflater();
			View item = inflater.inflate(R.layout.item_prod, null);
    		Producte prod = Controler.getInstance().getProducte(position);
			
			TextView tvNom = (TextView)item.findViewById(R.id.txtNomProd);
			tvNom.setText(prod.getNom());
			
			//TextView tvUnitats = (TextView)item.findViewById(R.id.txtUnitats);
			//tvUnitats.setText(prod.getUnitats() + "");
			
			return(item);
		}
    }

}
